#include <LEDA/polygon.h>
#include <LEDA/gen_polygon.h>
#include <LEDA/window.h>
#include <LEDA/geowin.h>
#include <Math.h>

using namespace leda;


class Ray_crossings {
    public:
       bool ray_crossings(const polygon& P, const point p);
};


bool Ray_crossings::ray_crossings(const polygon& P, const point q)
{
   point a , b;
   segment s;
   int max = 2147483647 ;
   point r(max, q.ycoord() );
   point r_links( -max , q.ycoord() );
   //horizontal ray from test point q in direction +x
   segment ray(q,r) ;
   //horizontal ray from test point q in direction -x
   segment ray_reverse(q,r_links);
   int crossings = 0 ;
   int crossings2 = 0  ;
   
   forall_segments(s,P)
   {
      a = s.start();
      b = s.end();
      //if the ray intersects a segment of the polygon, decide wether...   
      double qy = q.ycoord() ;     
      double ay = a.ycoord() ; 
      double by = b.ycoord() ;
      bool intersection_ray = ray.intersection(s);
      bool intersection_ray_reverse = ray_reverse.intersection(s);
      //case 1: b lies on horizontal ray through q und a lies above
      if (intersection_ray && (qy==by && qy < ay)) crossings++;
      //case 2: a lies on horizontal ray through q und b lies above
      if (intersection_ray && (qy==ay && qy < by)) crossings++;
      //case 3: a lies below horizontal ray through q and b above
      if (intersection_ray && (qy > ay && qy < by)) crossings++;
      //case 4: b lies below horizontal ray through q and b above
      if (intersection_ray && (qy > by && qy < ay)) crossings++;
      
      //case 1: b lies on horizontal ray through q und a below
      if (intersection_ray_reverse && (qy ==by && qy > ay)) crossings2++;
      //case 2: a lies on horizontal ray through q und b below
      if (intersection_ray_reverse && (qy ==ay && qy > by)) crossings2++;
      //case 3: a lies below horizontal ray through q und b above     
      if (intersection_ray_reverse && (qy > ay && qy < by)) crossings2++;
      //case 4: b lies below horizontal ray through q und a above
      if (intersection_ray_reverse && (qy > by && qy < ay)) crossings2++;
   }
   
   //if #crossings odd the point is inside the polygon, else it's outside
   if (crossings % 2 == 1 && crossings2 % 2 == 1) return true;
   else return false;
}


